diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-remote-station-manager.h ns-3.44/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.43/src/wifi/model/wifi-remote-station-manager.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-remote-station-manager.h	2025-03-09 16:55:49.803372600 -0700
@@ -1253,65 +1292,74 @@
     /**
      * Return the number of supported streams the station has.
      *
-     * \param station the station being queried
+     * @param station the station being queried
      *
-     * \return the number of supported streams the station has
+     * @return the number of supported streams the station has
      */
     uint8_t GetNumberOfSupportedStreams(const WifiRemoteStation* station) const;
     /**
-     * \returns the number of Ness the station has.
+     * @returns the number of Ness the station has.
      *
-     * \param station the station being queried
+     * @param station the station being queried
      *
-     * \return the number of Ness the station has
+     * @return the number of Ness the station has
      */
     uint8_t GetNess(const WifiRemoteStation* station) const;
 
+    uint8_t m_linkId;             //!< the ID of the link this object is associated with
+    bool m_incrRetryCountUnderBa; //!< whether  to increment the retry count of frames that are
+                                  //!< part of a Block Ack agreement
+
   private:
     /**
      * If the given TXVECTOR is used for a MU transmission, return the STAID of
      * the station with the given address if we are an AP or our own STAID if we
      * are a STA associated with some AP. Otherwise, return SU_STA_ID.
      *
-     * \param address the address of the station
-     * \param txVector the TXVECTOR used for a MU transmission
-     * \return the STA-ID of the station
+     * @param address the address of the station
+     * @param txVector the TXVECTOR used for a MU transmission
+     * @return the STA-ID of the station
      */
     uint16_t GetStaId(Mac48Address address, const WifiTxVector& txVector) const;
 
     /**
-     * \param station the station that we need to communicate
-     * \param size the size of the frame to send in bytes
-     * \param normally indicates whether the normal 802.11 RTS enable mechanism would
+     * Increment the retry count (if needed) for the given PSDU, whose transmission failed.
+     *
+     * @param station the station the PSDU is addressed to
+     * @param psdu the given PSDU
+     */
+    virtual void DoIncrementRetryCountOnTxFailure(WifiRemoteStation* station, Ptr<WifiPsdu> psdu);
+
+    /**
+     * Find the MPDUs to drop (possibly based on their frame retry count) in the given PSDU,
+     * whose transmission failed.
+     *
+     * @param station the station the PSDU is addressed to
+     * @param psdu the given PSDU
+     * @return the MPDUs in the PSDU to drop
+     */
+    virtual std::list<Ptr<WifiMpdu>> DoGetMpdusToDropOnTxFailure(WifiRemoteStation* station,
+                                                                 Ptr<WifiPsdu> psdu);
+
+    /**
+     * @param station the station that we need to communicate
+     * @param size the size of the frame to send in bytes
+     * @param normally indicates whether the normal 802.11 RTS enable mechanism would
      *        request that the RTS is sent or not.
      *
-     * \return true if we want to use an RTS/CTS handshake for this frame before sending it,
+     * @return true if we want to use an RTS/CTS handshake for this frame before sending it,
      *         false otherwise.
      *
      * Note: This method is called before a unicast packet is sent on the medium.
      */
     virtual bool DoNeedRts(WifiRemoteStation* station, uint32_t size, bool normally);
     /**
-     * \param station the station that we need to communicate
-     * \param packet the packet to send
-     * \param normally indicates whether the normal 802.11 data retransmission mechanism
-     *        would request that the data is retransmitted or not.
-     * \return true if we want to resend a packet after a failed transmission attempt,
-     *         false otherwise.
-     *
-     * Note: This method is called after any unicast packet transmission (control, management,
-     *       or data) has been attempted and has failed.
-     */
-    virtual bool DoNeedRetransmission(WifiRemoteStation* station,
-                                      Ptr<const Packet> packet,
-                                      bool normally);
-    /**
-     * \param station the station that we need to communicate
-     * \param packet the packet to send
-     * \param normally indicates whether the normal 802.11 data fragmentation mechanism
+     * @param station the station that we need to communicate
+     * @param packet the packet to send
+     * @param normally indicates whether the normal 802.11 data fragmentation mechanism
      *        would request that the data packet is fragmented or not.
      *
-     * \return true if this packet should be fragmented,
+     * @return true if this packet should be fragmented,
      *         false otherwise.
      *
      * Note: This method is called before sending a unicast packet.
@@ -1320,22 +1368,22 @@
                                      Ptr<const Packet> packet,
                                      bool normally);
     /**
-     * \return a new station data structure
+     * @return a new station data structure
      */
     virtual WifiRemoteStation* DoCreateStation() const = 0;
     /**
-     * \param station the station that we need to communicate
-     * \param allowedWidth the allowed width to send a packet to the station
-     * \return the TXVECTOR to use to send a packet to the station
+     * @param station the station that we need to communicate
+     * @param allowedWidth the allowed width to send a packet to the station
+     * @return the TXVECTOR to use to send a packet to the station
      *
      * Note: This method is called before sending a unicast packet or a fragment
      *       of a unicast packet to decide which transmission mode to use.
      */
     virtual WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, MHz_u allowedWidth) = 0;
     /**
-     * \param station the station that we need to communicate
+     * @param station the station that we need to communicate
      *
-     * \return the transmission mode to use to send an RTS to the station
+     * @return the transmission mode to use to send an RTS to the station
      *
      * Note: This method is called before sending an RTS to a station
      *       to decide which transmission mode to use for the RTS.
@@ -1346,24 +1394,24 @@
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we failed to send RTS
+     * @param station the station that we failed to send RTS
      */
     virtual void DoReportRtsFailed(WifiRemoteStation* station) = 0;
     /**
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we failed to send DATA
+     * @param station the station that we failed to send DATA
      */
     virtual void DoReportDataFailed(WifiRemoteStation* station) = 0;
     /**
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we successfully sent RTS
-     * \param ctsSnr the SNR of the CTS we received
-     * \param ctsMode the WifiMode the receiver used to send the CTS
-     * \param rtsSnr the SNR of the RTS we sent
+     * @param station the station that we successfully sent RTS
+     * @param ctsSnr the SNR of the CTS we received
+     * @param ctsMode the WifiMode the receiver used to send the CTS
+     * @param rtsSnr the SNR of the RTS we sent
      */
     virtual void DoReportRtsOk(WifiRemoteStation* station,
                                double ctsSnr,
@@ -1373,12 +1421,12 @@
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we successfully sent RTS
-     * \param ackSnr the SNR of the ACK we received
-     * \param ackMode the WifiMode the receiver used to send the ACK
-     * \param dataSnr the SNR of the DATA we sent
-     * \param dataChannelWidth the channel width of the DATA we sent
-     * \param dataNss the number of spatial streams used to send the DATA
+     * @param station the station that we successfully sent RTS
+     * @param ackSnr the SNR of the ACK we received
+     * @param ackMode the WifiMode the receiver used to send the ACK
+     * @param dataSnr the SNR of the DATA we sent
+     * @param dataChannelWidth the channel width of the DATA we sent
+     * @param dataNss the number of spatial streams used to send the DATA
      */
     virtual void DoReportDataOk(WifiRemoteStation* station,
                                 double ackSnr,
@@ -1390,23 +1438,23 @@
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we failed to send RTS
+     * @param station the station that we failed to send RTS
      */
     virtual void DoReportFinalRtsFailed(WifiRemoteStation* station) = 0;
     /**
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that we failed to send DATA
+     * @param station the station that we failed to send DATA
      */
     virtual void DoReportFinalDataFailed(WifiRemoteStation* station) = 0;
     /**
      * This method is a pure virtual method that must be implemented by the sub-class.
      * This allows different types of WifiRemoteStationManager to respond differently,
      *
-     * \param station the station that sent the DATA to us
-     * \param rxSnr the SNR of the DATA we received
-     * \param txMode the WifiMode the sender used to send the DATA
+     * @param station the station that sent the DATA to us
+     * @param rxSnr the SNR of the DATA we received
+     * @param txMode the WifiMode the sender used to send the DATA
      */
     virtual void DoReportRxOk(WifiRemoteStation* station, double rxSnr, WifiMode txMode) = 0;
     /**
@@ -1415,14 +1463,14 @@
      * be implemented by the sub-class intended to handle A-MPDUs. This allows different
      * types of WifiRemoteStationManager to respond differently.
      *
-     * \param station the station that sent the DATA to us
-     * \param nSuccessfulMpdus number of successfully transmitted MPDUs.
+     * @param station the station that sent the DATA to us
+     * @param nSuccessfulMpdus number of successfully transmitted MPDUs.
      *        A value of 0 means that the Block ACK was missed.
-     * \param nFailedMpdus number of unsuccessfuly transmitted MPDUs.
-     * \param rxSnr received SNR of the block ack frame itself
-     * \param dataSnr data SNR reported by remote station
-     * \param dataChannelWidth the channel width of the A-MPDU we sent
-     * \param dataNss the number of spatial streams used to send the A-MPDU
+     * @param nFailedMpdus number of unsuccessfuly transmitted MPDUs.
+     * @param rxSnr received SNR of the block ack frame itself
+     * @param dataSnr data SNR reported by remote station
+     * @param dataChannelWidth the channel width of the A-MPDU we sent
+     * @param dataNss the number of spatial streams used to send the A-MPDU
      */
     virtual void DoReportAmpduTxStatus(WifiRemoteStation* station,
                                        uint16_t nSuccessfulMpdus,
@@ -1435,16 +1483,16 @@
     /**
      * Return the state of the station associated with the given address.
      *
-     * \param address the address of the station
-     * \return WifiRemoteStationState corresponding to the address
+     * @param address the address of the station
+     * @return WifiRemoteStationState corresponding to the address
      */
     std::shared_ptr<WifiRemoteStationState> LookupState(Mac48Address address) const;
     /**
      * Return the station associated with the given address.
      *
-     * \param address the address of the station
+     * @param address the address of the station
      *
-     * \return WifiRemoteStation corresponding to the address
+     * @return WifiRemoteStation corresponding to the address
      */
     WifiRemoteStation* Lookup(Mac48Address address) const;
 
@@ -1452,21 +1500,21 @@
      * Actually sets the fragmentation threshold, it also checks the validity of
      * the given threshold.
      *
-     * \param threshold the fragmentation threshold
+     * @param threshold the fragmentation threshold
      */
     void DoSetFragmentationThreshold(uint32_t threshold);
     /**
      * Return the current fragmentation threshold
      *
-     * \return the fragmentation threshold
+     * @return the fragmentation threshold
      */
     uint32_t DoGetFragmentationThreshold() const;
     /**
      * Return the number of fragments needed for the given packet.
      *
-     * \param mpdu the packet to be fragmented
+     * @param mpdu the packet to be fragmented
      *
-     * \return the number of fragments needed
+     * @return the number of fragments needed
      */
     uint32_t GetNFragments(Ptr<const WifiMpdu> mpdu);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.h	2025-03-09 16:55:49.803372600 -0700
@@ -22,7 +22,7 @@
 class SpectrumWifiPhy;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * This class is an adaptor between class SpectrumWifiPhy (which inherits
  * from WifiPhy) and class SpectrumChannel (which expects objects derived
@@ -36,25 +36,25 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     /**
      * Constructor
      *
-     * \param freqRange the frequency range covered by the interface
+     * @param freqRange the frequency range covered by the interface
      */
     WifiSpectrumPhyInterface(FrequencyRange freqRange);
     /**
      * Connect SpectrumWifiPhy object
-     * \param phy SpectrumWifiPhy object to be connected to this object
+     * @param phy SpectrumWifiPhy object to be connected to this object
      */
     void SetSpectrumWifiPhy(const Ptr<SpectrumWifiPhy> phy);
 
     /**
      * Get SpectrumWifiPhy object
-     * \return Pointer to SpectrumWifiPhy object
+     * @return Pointer to SpectrumWifiPhy object
      */
     Ptr<const SpectrumWifiPhy> GetSpectrumWifiPhy() const;
 
@@ -70,14 +70,14 @@
     /**
      * Get the spectrum channel this interface is attached to
      *
-     * \return the spectrum channel this interface is attached to
+     * @return the spectrum channel this interface is attached to
      */
     Ptr<SpectrumChannel> GetChannel() const;
 
     /**
      * Get the frequency range covered by the spectrum channel this interface is attached to
      *
-     * \return the frequency range covered by the spectrum channel this interface is attached to
+     * @return the frequency range covered by the spectrum channel this interface is attached to
      */
     const FrequencyRange& GetFrequencyRange() const;
 
@@ -85,7 +85,7 @@
      * Get the center frequency for each segment of the the spectrum channel this interface is
      * attached to
      *
-     * \return the center frequency for each segment of the the spectrum channel this interface is
+     * @return the center frequency for each segment of the the spectrum channel this interface is
      * attached to to
      */
     const std::vector<MHz_u>& GetCenterFrequencies() const;
@@ -93,7 +93,7 @@
     /**
      * Get the channel width covered by the spectrum channel this interface is attached to
      *
-     * \return the channel width covered by the spectrum channel this interface is attached
+     * @return the channel width covered by the spectrum channel this interface is attached
      * to to
      */
     MHz_u GetChannelWidth() const;
@@ -101,17 +101,17 @@
     /**
      * Start transmission over the spectrum channel
      *
-     * \param params the parameters of the signal to transmit
+     * @param params the parameters of the signal to transmit
      */
     void StartTx(Ptr<SpectrumSignalParameters> params);
 
     /**
      * Set the RX spectrum model
      *
-     * \param centerFrequencies the center frequency for each segment
-     * \param channelWidth the total channel width
-     * \param bandBandwidth the width of each band
-     * \param guardBandwidth the total width of the guard band
+     * @param centerFrequencies the center frequency for each segment
+     * @param channelWidth the total channel width
+     * @param bandBandwidth the width of each band
+     * @param guardBandwidth the total width of the guard band
      */
     void SetRxSpectrumModel(const std::vector<MHz_u>& centerFrequencies,
                             MHz_u channelWidth,
@@ -121,26 +121,26 @@
     /**
      * Set the vector of spectrum bands handled by this interface
      *
-     * \param bands vector of spectrum bands
+     * @param bands vector of spectrum bands
      */
     void SetBands(WifiSpectrumBands&& bands);
     /**
      * Get the vector of spectrum bands handled by this interface
      *
-     * \return the vector of spectrum bands
+     * @return the vector of spectrum bands
      */
     const WifiSpectrumBands& GetBands() const;
 
     /**
      * Set the HE RU spectrum bands handled by this interface (if any)
      *
-     * \param heRuBands the HE RU spectrum bands
+     * @param heRuBands the HE RU spectrum bands
      */
     void SetHeRuBands(HeRuBands&& heRuBands);
     /**
      * Get the HE RU spectrum bands handled by this interface
      *
-     * \return the HE RU spectrum bands
+     * @return the HE RU spectrum bands
      */
     const HeRuBands& GetHeRuBands() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.h ns-3.44/src/wifi/model/wifi-spectrum-signal-parameters.h
--- ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-spectrum-signal-parameters.h	2025-03-09 16:55:49.803372600 -0700
@@ -20,7 +20,7 @@
 class WifiPpdu;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Signal parameters for wifi
  */
@@ -36,7 +36,7 @@
     /**
      * copy constructor
      *
-     * \param p the wifi spectrum signal parameters
+     * @param p the wifi spectrum signal parameters
      */
     WifiSpectrumSignalParameters(const WifiSpectrumSignalParameters& p);
 
